function [d_lag, max_TDC, TDC]=dominant_lag_maximum_TDC(data1, data2, t, maxlag)

%function calculates dominant lag and maximum of tail dependence
%coefficient with time lag

%data1, data2 - time series of data
%t - threshold, ex. 0.95
%maxlag - largest time lag to be considered

TDC=tail_dependence(data1, data2, t, maxlag);
for i=1:length(t)
    d_all=((TDC(i,:)==max(TDC(i,:))).*(-maxlag:(maxlag)));
    if(sum(d_all)==0)
        d_lag(i)=0;
    else
        d_lag(i)=ceil(mean(d_all(d_all~=0)));
    end;
end;
 max_TDC=max(TDC');