function [d_lag, min_gamma, gamma]=dominant_lag_minimum_ev(data1, data2, t, maxlag)

%function calculates dominant lag, and minimum of extremal variogram

%data1, data2 - time series of data
%t - threshold, ex. 0.95
%maxlag - largest time lag to be considered

gamma=extremal_variogram(data1, data2, t, maxlag);
for i=1:length(t)
    d_all=((gamma(i,:)==min(gamma(i,:))).*(-maxlag:(maxlag)));
    if(sum(d_all)==0)
        d_lag(i)=0;
    else
        d_lag(i)=ceil(mean(d_all(d_all~=0)));
    end;
end;
gamma(gamma<0)=0;
min_gamma=min(gamma');