function gamma=extremal_variogram(data1, data2, t, maxlag)

%function calculates extremal variogram with time lag

%data1, data2 - time series of data
%t - threshold, ex. 0.95
%maxlag - largest time lag to be considered

n=length(data1);

for j=1:n
        d1(j)=sum(data1(j)>data1);
        d2(j)=sum(data2(j)>data2);
end;

d1=d1./max(d1);
d2=d2./max(d2);

S=-1./log(d1);
T=-1./log(d2);

for i=1:length(t)
    s=-1./log(t(i));
    for j=1:maxlag
        Z=min(S((maxlag+2-j):(end-j+1)),T(1:(end-maxlag)));
        z_desc=sort(Z,'descend');
        k1=sum(z_desc>=s);
        if k1>0
            gamma(i,j)=2-2./(k1).*(sum(log(z_desc(1:(k1))./z_desc(k1))));
        else
            gamma(i,j)=NaN;
        end
    end;
    Z=min(S(1:(end-maxlag)),T(1:(end-maxlag)));
    z_desc=sort(Z,'descend');
    k1=sum(z_desc>=s);
    if k1>0
        gamma(i,maxlag+1)=2-2./(k1).*(sum(log(z_desc(1:(k1))./z_desc(k1))));
    else
        gamma(i,maxlag+1)=NaN;
    end
    for j=1:maxlag 
        Z=min(S(1:(end-maxlag)),T((1+j):(end-maxlag+j)));
        z_desc=sort(Z,'descend');
        k1=sum(z_desc>=s);
        if k1>0
            gamma(i,maxlag+1+j)=2-2./(k1).*(sum(log(z_desc(1:(k1))./z_desc(k1))));
        else
            gamma(i,maxlag+1+j)=NaN;
        end
    end;
end