function TDC=tail_dependence(data1, data2, t, maxlag)

%function calculates tail dependence coefficient with time lag

%data1, data2 - time series of data
%t - threshold, ex. 0.95
%maxlag - largest time lag to be considered

n=length(data1);
d_asc1=sort(data1);
d_asc2=sort(data2);
ranks1=zeros(1,n);
ranks2=zeros(1,n);
v1=find(data1==d_asc1(1));
ranks1(v1)=1;
v2=find(data2==d_asc2(1));
ranks2(v2)=1;
for i=2:n
    if (d_asc1(i)>d_asc1(i-1))
        v1=find(data1==d_asc1(i));
        ranks1(v1)=i;
    end;
    if (d_asc2(i)>d_asc2(i-1))
        v2=find(data2==d_asc2(i));
        ranks2(v2)=i;
    end;
end;

for i=1:length(t)
n1=max(ranks1);
n2=max(ranks2);
k1(i)=floor((1-t(i))*(n1+1));
k2(i)=floor((1-t(i))*(n2+1));
    for j=1:maxlag
        TDC(i,j)=sum((ranks1((maxlag+2-j):end)>n1-k1(i)).*(ranks2(1:(end-maxlag+j-1))>n2-k2(i)))/(k1(i)+k2(i))*2;
    end;
    TDC(i,maxlag+1)=sum((ranks1>n1-k1(i)).*(ranks2>n2-k2(i)))/(k1(i)+k2(i))*2;
    for j=1:maxlag 
        TDC(i,maxlag+1+j)=sum((ranks2((1+j):end)>n2-k2(i)).*(ranks1(1:(end-j))>n1-k1(i)))/(k1(i)+k2(i))*2;
    end;
end;