function w_TDC=window_TDC(data1, data2, t, w)

%Function calculates window tail dependence coefficient

%data1, data2 - time series of data
%t - threshold, ex. 0.95
%w - time window in which dependence is considered

n=length(data1);
d_asc1=sort(data1);
d_asc2=sort(data2);
ranks1=zeros(1,n);
ranks2=zeros(1,n);
v1=find(data1==d_asc1(1));
ranks1(v1)=1;
v2=find(data2==d_asc2(1));
ranks2(v2)=1;
for i=2:n
    if (d_asc1(i)>d_asc1(i-1))
        v1=find(data1==d_asc1(i));
        ranks1(v1)=i;
    end;
    if (d_asc2(i)>d_asc2(i-1))
        v2=find(data2==d_asc2(i));
        ranks2(v2)=i;
    end;
end;

for i=1:length(t)
    n1=max(ranks1);
    n2=max(ranks2);
    k1(i)=floor((1-t(i))*(n1+1));
    k2(i)=floor((1-t(i))*(n2+1));
    s1_ranks=ranks1>(n1-k1(i));
    s2_ranks=ranks2>(n2-k2(i));
    s1=max(reshape(s1_ranks(1:(floor(n/w)*w)),w,floor(n/w)));
    s2=max(reshape(s2_ranks(1:(floor(n/w)*w)),w,floor(n/w)));
    s=s1.*s2;
    w_TDC(i)=sum(s)/(sum(s1)+sum(s2))*2;
end;